#ifndef __3DMATH_H__
#define __3DMATH_H__
#include <stdio.h>
#include <math.h>
#include "structures.h"
#include "cpysys.h"
#define DEGREE .0174528f
#ifdef __C_PLUS_PLUS__
extern "C"{
#endif
 float VMul(void*,void*);
 float DotMul(void*,void*);
 void RotateYX(void*,void*,t2DPoint*);
 void RotateXY(void*,void*,t2DPoint*);
 void RotatePoint(void*,void*,t3DPoint*);
 void RotatePointRw(void*,void*,t3DPoint*);
 void RotatePoint2(void*,void*,t3DPoint*);
 void RotatePointRw2(void*,void*,t3DPoint*);
#define ABSOLUTEf(n,m) asm __volatile__("andl $0x7FFFFFFF,%%eax\n\t":"=a"(*((int*)&n)):"a"(*((int*)&m)))
#define lequsig(n,m) ((n>>31)^(m>>31))
#define wequsig(n,m) ((n>>15)^(m>>15))
#define bequsig(n,m) (((n>>7)^(m>>7)))
#define cequsig(n,m) (((n>>7)^(m>>7)))
 int fequsig(float,float);
 int FindQ(t2DPlane*,void*,void*,void*);
 int xFindQ(t2DPlane*,void*,void*,void*,float*);
 void MLQuickSortf(void*,unsigned int,unsigned int,signed long,signed long);
 void MLQuickSortl(void*,unsigned int,unsigned int,signed long,signed long);
 void MLQuickSorti(void*,unsigned int,unsigned int,signed long,signed long);
 void MLQuickSortw(void*,unsigned int,unsigned int,signed long,signed long);
 void MLQuickSorts(void*,unsigned int,unsigned int,signed long,signed long);
 void MLQuickSortb(void*,unsigned int,unsigned int,signed long,signed long);
 void MLQuickSortc(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSortf(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSortl(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSorti(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSortw(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSorts(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSortb(void*,unsigned int,unsigned int,signed long,signed long);
 void LMQuickSortc(void*,unsigned int,unsigned int,signed long,signed long);
 int GetSide(void*,t2DPlane*);
 int GetSide2(void*,t2DPlane*);
 int Inside(void*,t2DPlane*);
 int FindIntersection(t2DPlane*,void*,void*);
 int FindIntersection2(t2DPlane*,void*,void*);
 int CheckCircleOrSphereCollision(tCircleOrCube*,tCircleOrCube*);
 void CalculateNormal(void*,void*,void*,t3DPoint*);
 unsigned int FindClosestLMf(void*,unsigned int,unsigned int,float,long,long);
 unsigned int FindClosestMLf(void*,unsigned int,unsigned int,float,long,long);
 unsigned int FindClosestLMi(void*,unsigned int,unsigned int,int,long,long);
 unsigned int FindClosestMLi(void*,unsigned int,unsigned int,int,long,long);
 unsigned int FindClosestLMw(void*,unsigned int,unsigned int,unsigned short,long,long);
 unsigned int FindClosestMLw(void*,unsigned int,unsigned int,unsigned short,long,long);
 unsigned int FindClosestLMl(void*,unsigned int,unsigned int,unsigned int,long,long);
 unsigned int FindClosestMLl(void*,unsigned int,unsigned int,unsigned int,long,long);
 unsigned int FindClosestLMs(void*,unsigned int,unsigned int,signed int,long,long);
 unsigned int FindClosestMLs(void*,unsigned int,unsigned int,signed int,long,long);
 void FindPlane(void*,void*,void*,t2DPlane*);
 void FindPlane2(void*,void*,void*,t2DPlane*);
 void ProjectPoint(void*,void*,float);
 void DeprojectPoint(float,void*,void*,float*);
 float P2L(void*,void*,void*);
 char chkP2L(float,void*,void*,void*);
 int PointNormalPrj(t2DPlane*,void*,void*);
 void PointNormalPrjNorma1(t2DPlane*,void*,void*);
 int FindQ2(t2DPlane*,void*,void*,void*);
 int FindQ3(t2DPlane*,void*,void*,void*);
 int xFindQ2(t2DPlane*,void*,void*,void*,float*);
 int xFindQ3(t2DPlane*,void*,void*,void*,float*);
 int FindQnear(t2DPlane*,void*,void*,float,void*);
 float sqP2P(void*,void*);
 void GetOffXY(int,int,void*);
 int ProjectVector(void*,void*,t2DPlane*,void*);
 char OkAngle(char,float,t3DPoint*,t3DPoint*,t3DPoint*);
 char OkDegrees(char,float,t3DPoint*,t3DPoint*,t3DPoint*);
#ifdef __C_PLUS_PLUS__
}
#endif
#endif
